Description

I noticed the problem that users cannot know whether there are any attachments unless users expand the "File" section by clicking it.

To resolve the problem, I suggest showing attachments count on "Files” section.

Please see the screenshots below for the details.
Patch: show_attachments_count_of_wiki_page_trunk_r16963.patch

(Compatible the latest trunk r16963.)

Related issues:

Related to Redmine - Feature #27085: Display a counter beside each tab New

Related to Redmine - Feature #12183: Hide attachments by default on wiki pages Closed

Has duplicate Redmine - Feature #28893: Show number of attached files in Wiki... Closed

Associated revisions

Revision 17231 - 2018-03-10 03:36 - Go MAEDA

Show the number of attachments on wiki pages (#27090).

Patch by Tomomi Yuzuriha.

Revision 17364 - 2018-06-03 07:00 - Go MAEDA

Merged r17231 from trunk to 3.4-stable (#27090).

History

#1 - 2017-09-28 14:27 - Mischa The Evil

- Target version set to Unplanned backlogs

Nice one, although it can slow down wiki page rendering if a page contains lots of attachments.

#2 - 2017-10-27 09:43 - Toshi MARUYAMA

- Related to Feature #27085: Display a counter beside each tab added

#3 - 2017-11-07 01:03 - arturo flores

Alternatively, is there a way of having the files section by expanded by default?

#4 - 2018-01-14 11:14 - Go MAEDA

- File show_attachments_count_of_wiki_page-v2.diff added

Mischa The Evil wrote:

Nice one, although it can slow down wiki page rendering if a page contains lots of attachments.
https://www.redmine.org/attachments/19251
https://www.redmine.org/projects/redmine/repository/svn/revisions/16963


 I slightly improved the Tomomi Yuzuriha's patch to avoid the slowdown caused by additional SQL query ("SELECT COUNT(*) FROM ..."). I replaced 

count  method with length method. With this change, I think the slowdown that Mischa wrote will never happen.

Vanilla Redmine:

  Attachment Load (0.4ms)  SELECT "attachments".* FROM "attachments" WHERE "attachments"."container_id" = ? AN

D "attachments"."container_type" = ? ORDER BY attachments.created_on ASC, attachments.id ASC  [["container_id"

, 1], ["container_type", "WikiPage"]]

  Rendered wiki/_content.html.erb (147.0ms)

  CACHE Attachment Load (0.0ms)  SELECT "attachments".* FROM "attachments" WHERE "attachments"."container_id" 

= ? AND "attachments"."container_type" = ? ORDER BY attachments.created_on ASC, attachments.id ASC  [["contain

er_id", 1], ["container_type", "WikiPage"]]

 With Tomomi Yuzuriha's patch applied:

It requires one more query ("SELECT COUNT(*) FROM ..."). It can cause the slowdown as Mishca pointed out.

  Attachment Load (0.2ms)  SELECT "attachments".* FROM "attachments" WHERE "attachments"."container_id" = ? AN

D "attachments"."container_type" = ? ORDER BY attachments.created_on ASC, attachments.id ASC  [["container_id"

, 1], ["container_type", "WikiPage"]]

  Rendered wiki/_content.html.erb (74.0ms)

   (0.2ms)  SELECT COUNT(*) FROM "attachments" WHERE "attachments"."container_id" = ? AND "attachments"."conta

iner_type" = ?  [["container_id", 1], ["container_type", "WikiPage"]]

  CACHE Attachment Load (0.0ms)  SELECT "attachments".* FROM "attachments" WHERE "attachments"."container_id" 

= ? AND "attachments"."container_type" = ? ORDER BY attachments.created_on ASC, attachments.id ASC  [["contain

er_id", 1], ["container_type", "WikiPage"]]

 Replaced count with length:

Queries are identical with vanilla Redmine. There isn't "SELECT COUNT(*) FROM ..." which can cause the slowdown.

  Attachment Load (0.2ms)  SELECT "attachments".* FROM "attachments" WHERE "attachments"."container_id" = ? AN

D "attachments"."container_type" = ? ORDER BY attachments.created_on ASC, attachments.id ASC  [["container_id"

, 1], ["container_type", "WikiPage"]]

  Rendered wiki/_content.html.erb (151.1ms)

  CACHE Attachment Load (0.0ms)  SELECT "attachments".* FROM "attachments" WHERE "attachments"."container_id" 

= ? AND "attachments"."container_type" = ? ORDER BY attachments.created_on ASC, attachments.id ASC  [["contain

er_id", 1], ["container_type", "WikiPage"]]

#5 - 2018-01-15 23:30 - Go MAEDA

- Target version changed from Unplanned backlogs to 4.1.0

I am setting target version to 4.1.0.

#6 - 2018-03-10 03:30 - Go MAEDA

- Related to Feature #12183: Hide attachments by default on wiki pages added

#7 - 2018-03-10 03:38 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Target version changed from 4.1.0 to 4.0.0

Committed. Thank you for your contribution.

#8 - 2018-03-10 03:39 - Go MAEDA

- Subject changed from Show attachments count in "Files” section of the Wiki page to Show the number of attachments on wiki pages

#9 - 2018-05-28 00:26 - Go MAEDA

- Has duplicate Feature #28893: Show number of attached files in Wiki Files-Link added

#10 - 2018-06-03 06:58 - Go MAEDA

- Status changed from Closed to Reopened

- Target version changed from 4.0.0 to 3.4.6
http://api.rubyonrails.org/classes/ActiveRecord/Associations/CollectionProxy.html#method-i-count
http://api.rubyonrails.org/classes/ActiveRecord/Associations/CollectionProxy.html#method-i-length


This change is very small but useful. I think it should be delivered as soon as possible.

#11 - 2018-06-03 07:00 - Go MAEDA

- Status changed from Reopened to Closed

Merged to 3.4-stable branch.
